"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function dfs(src, dest, msg = null) {
    const cur = msg ? `${msg}` : '';
    for (const validationError of src) {
        if (validationError.constraints) {
            for (const key in validationError.constraints) {
                if (validationError.constraints[key]) {
                    const formatProperty = cur ? `.${validationError.property}` : `${validationError.property}`;
                    const field = isNaN(parseInt(validationError.property, 10))
                        ? formatProperty
                        : `[${validationError.property}]`;
                    dest.push({
                        field: `${cur}${field}`,
                        message: `${validationError.constraints[key]}`,
                    });
                }
            }
        }
        if (validationError.children && validationError.children.length) {
            const formatProperty = cur ? `.${validationError.property}` : `${validationError.property}`;
            const field = isNaN(parseInt(validationError.property, 10))
                ? formatProperty
                : `[${validationError.property}]`;
            dfs(validationError.children, dest, `${cur}${field}`);
        }
    }
}
class MessageFormatter {
    static format(validationErrors) {
        const dest = [];
        dfs(validationErrors, dest);
        return dest;
    }
}
exports.MessageFormatter = MessageFormatter;
